package speiger.src.coreengine.rendering.gui.renderer;

import java.util.function.Consumer;

import speiger.src.collections.objects.lists.ObjectArrayList;
import speiger.src.collections.utils.Stack;
import speiger.src.coreengine.math.misc.Facing;
import speiger.src.coreengine.math.vector.matrix.Matrix4f;
import speiger.src.coreengine.math.vector.matrix.Matrix4fStack;
import speiger.src.coreengine.math.vector.quaternion.Quaternion;
import speiger.src.coreengine.rendering.guiOld.helper.box.IGuiBox;
import speiger.src.coreengine.rendering.models.DrawCall;

public class SimpleUIRenderer implements IUIRenderer {
	TexturedRect cachedRect = new TexturedRect();
	Matrix4fStack transformCache = new Matrix4fStack();
	
	@Override
	public boolean isInScissors(IGuiBox box) {
		return false;
	}
	
	@Override
	public void pushScissors(IGuiBox box) {
		
	}
	
	@Override
	public void popScissors() {
		
	}
	
	@Override
	public TexturedRect getCachedRect() { return cachedRect; }
	
	@Override
	public void flush() {
		
	}
	
	@Override
	public void pushTransform() { transformCache.push(); }
	@Override
	public void popTransform() { transformCache.pop(); }
	@Override
	public void translate(float z) { transformCache.translateZ(z); }
	@Override
	public void translate(float x, float y) { transformCache.translate(x, y); }
	@Override
	public void translate(float x, float y, float z) { transformCache.translate(x, y, z); }
	@Override
	public void scale(float scale) { transformCache.scale(scale); }
	@Override
	public void scale(float x, float y) { transformCache.scale(x, y, 1F); }
	@Override
	public void rotate(Quaternion rotation) { transformCache.rotate(rotation); }
	
	@Override
	public void drawCustom(Consumer<Matrix4f> matrix) {
		flush();
	}
	
	@Override
	public void drawCustom(DrawCall drawcall) {
		
	}
	
	@Override
	public void drawLine(float minX, float minY, float maxX, float maxY, float zLevel, int color) {
		
	}
	
	@Override
	public void drawFrame(float minX, float minY, float maxX, float maxY, float zLevel, int color) {
		
	}
	
	@Override
	public void drawRect(float minX, float minY, float maxX, float maxY, float zLevel, int color) {
		
	}
	
	@Override
	public void drawGradientRect(float minX, float minY, float maxX, float maxY, float zLevel, int startColor, int endColor, Facing facing) {
		
	}
	
	@Override
	public void drawTexturedRect(float minX, float minY, float maxX, float maxY, float zLevel, int texture, float minU, float minV, float maxU, float maxV, int color) {
		
	}
	
}
